<?php
/* 
    Plugin Name: Custom Event Espresso Event Displayer
    Plugin URI: http://www.daryl-phillips.co.uk/2012/01/18/event-espresso-custom-event-display-plugin/
    Description: Plugin to use custom display methods as an expansion to Event Espresso. Use [CUSTOM_ESPRESSO_EVENT_DISPLAYER] shortcode on any given page to get the events listed.
    Author: D. Phillips
    Version: 1.2 
    Author URI: http://www.daryl-phillips.co.uk/

	Copyright 2012  Daryl Phillips  (email : wp_plugins@daryl-phillips.co.uk)
	Donate: http://www.daryl-phillips.co.uk/2012/01/18/event-espresso-custom-event-display-plugin/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
define("CUSTOM_ESPRESSO_EVENT_DISPLAY_PLUGINPATH", "/" . plugin_basename( dirname(__FILE__) ) . "/");
define("CUSTOM_ESPRESSO_EVENT_DISPLAY", WP_PLUGIN_URL . CUSTOM_ESPRESSO_EVENT_DISPLAY_PLUGINPATH );



//Build the short code
//[ESPRESSO_EVENT_DISPLAYER]
function display_events (){
	global $wpdb, $org_options;	
	$month_html = '<div id="months"><ul>';
	$html_to_echo = '';
	$years_html = '<div id="years"><p><!--YEAR_LOOP--></p></div>';
	$year_string = '';
	
	if(isset($_REQUEST['selectYear'])) {
		$current_year = $_REQUEST['selectYear'];	
	}
	else {
		$current_year = date("Y");
	}
	
	$url = explode("?", $_SERVER['REQUEST_URI']);
	
	//Years - Show 2 years in advance
	for($i = date("Y");$i<date("Y")+3;$i++) {
		if($current_year == $i) {
			$year_string .= '<span><strong>'.$i.'</strong></span> |';	
		}
		else {
			$year_string .= '<span><a href="'.$url[0].'?selectYear='.$i.'">'.$i.'</a></span> |';
		}
	}
	
	$year_string = substr($year_string, 0, strlen($year_string) - 2);
	$years_html = str_replace("<!--YEAR_LOOP-->", $year_string, $years_html);
	
	for($i = 1; $i < 13; $i++) {
		$month = $i;	
		
		$month_name = date("F", strtotime($current_year."-".$month."-01"));
		$month_name_abr = date("M", strtotime($current_year."-".$month."-01"));
		$month_end = lastOfMonth($month); //last day of the month
		
		$month_html .= '<li class="<!--class_name-->"><a href="#month_'.$month_name.'" title="View '.$month_name.' &raquo;">'.$month_name_abr.'</a></li>';
		
		if(date("F") == $month_name) {
			$class = '';
			if($month == 1) {
				$class = " first";
			}
			else if($month == 12) {
				$class = " last";	
			}
			
			$month_html = str_replace("<!--class_name-->", "active".$class, $month_html);
		}
		else {
			$class = '';
			if($month == 1) {
				$class = " first";
			}
			else if($month == 12) {
				$class = " last";	
			}
			$month_html = str_replace("<!--class_name-->", $class, $month_html);
		}
		
		
		$events = sprintf("SELECT e.* FROM %s e WHERE start_date >= '%s' AND end_date <= '%s' ORDER BY id ASC",
		mysql_real_escape_string(EVENTS_DETAIL_TABLE),			
		mysql_real_escape_string(date("Y-m-d", strtotime($current_year."-".$month."-01"))),			
		mysql_real_escape_string(date("Y-m-d", strtotime($current_year."-".$month."-".$month_end))));
		
		$events_data = $wpdb->get_results($events);
		
		$html_to_echo .= '<div id="month_'.$month_name.'" class="list_events"';
		
		if(date("F") != $month_name) {
			$html_to_echo .= ' style="display:none;">';	
		}
		else {
			$html_to_echo .= '>';	
		}
		
		if($events_data) {			
			$html_to_echo .= '<div class="month"><h3>'.$month_name.' '.$current_year.'</h3></div><div class="item">';
			foreach($events_data as $event) {
				$finished = '';

				
				if(time() > strtotime($event->start_date)) {
					$finished = 'style="background-color:#521d0a !important;"';	
				}
				
				$price_query = sprintf("SELECT event_cost FROM %s WHERE event_id = '%d'",
				mysql_real_escape_string(EVENTS_PRICES_TABLE),
				mysql_real_escape_string($event->id));
				
				$title = $event->event_name. " - ".date("jS M Y", strtotime($event->start_date));
				$title_size = strlen($title);
				
				$price_result = $wpdb->get_row($price_query);
				
				if($price_result) {
					$price = $price_result->event_cost;
					
					if($price > 0) {
						$price = $org_options['currency_symbol'].$price;	
					}
					else {
						$price = "<strong>FREE</strong>";	
					}
				}
				
				$event_url = '?page_id=' . $org_options['event_page_id'] . '&regevent_action=register&event_id=' . $event->id;
				
				$html_to_echo .= '<div class="item_left">';
				$html_to_echo .= '<div class="event_header" '.$finished.'><p>'.stripslashes($title).'</p></div>';
				$html_to_echo .= '<div class="event_desc"><p>'.createEventDesc($event->event_desc, $title).'</p></div>';
				if($finished == '') {
					$html_to_echo .= '<div class="event_price"><p>Price: '.$price.'</p></div>';
					$html_to_echo .= '<div class="event_more"><p><a href="'.$event_url.'" title="Register for this event &raquo;">Register for event &raquo;</a></p></div>';
				}
				else {
					$html_to_echo .= '<div class="event_more"><p><strong>This event has passed.</strong></p></div>';
				}
				$html_to_echo .= '</div>';
			}
			$html_to_echo .= '</div></div>';
		}
		else {			
			$html_to_echo .= '<div class="month"><h3>'.$month_name.' '.$current_year.'</h3></div>';
			$html_to_echo .= "<div><p>Sorry, there are no events planned for ".$month_name." ".$current_year.". Please check other months for event availability.</p></div></div>";	
		}
	}
	//End of For loop
	
	$html_to_echo = '<div id="month_holder">'.$html_to_echo.'</div>';
	
	if($html_to_echo != '') {
		echo $years_html.$month_html."</ul></div>".$html_to_echo;?>

        <link rel="stylesheet" href="<?=CUSTOM_ESPRESSO_EVENT_DISPLAY?>/eventdisplay.css" />
        <script type="text/javascript" src="<?=CUSTOM_ESPRESSO_EVENT_DISPLAY?>/scripts/eventdisplayer.js"></script>	
	<?php }
	else {
		echo "<p>I'm sorry no events have been found please try again later.</p>";	
	}
}
add_shortcode('CUSTOM_ESPRESSO_EVENT_DISPLAYER', 'display_events');

function lastOfMonth($month) {
	return date("d", strtotime('-1 second',strtotime('+1 month',strtotime($month.'/01/'.date('Y').' 00:00:00'))));
}

function calculatePrice($event_id) {
	global $wpdb, $org_options;
	
	$price_query = sprintf("SELECT event_cost FROM %s WHERE event_id = '%d'",
	mysql_real_escape_string(EVENTS_PRICES_TABLE),
	mysql_real_escape_string($event_id));
	
	$price_result = $wpdb->get_row($price_query);
	
	if($price_result) {
		$price = $price_result->event_cost;
		
		if($price > 0) {
			$price = $org_options['currency_symbol'].$price;	
		}
		else {
			$price = "<strong>FREE</strong>";	
		}
	}
	return $price;
}

function createEventDesc($desc, $title_size) {
	$desc = preg_replace('/<img[^>]+./','',$desc);
	$desc = explode(".", strip_tags($desc));
	$desc = $desc[0].$desc[1].$desc[2].$desc[3].".";
	
	if(strlen($desc) > 175) {
		$subtract = 175;
		if($title_size > 25) {
			$subtract = 0;
			$subtract = 200 - $title_size;	
		}
		$desc = substr($desc, 0, $subtract)."...";	
	}	
	return stripslashes($desc);
}